// Generated by CoffeeScript 1.9.2
var Button, ButtonGroup, ButtonToolbar, DatePicker, DateTime, DropdownButton, Glyphicon, Input, MenuItem, MonthPicker, PickerMixin, PropTypes, Table, TimePicker, YearPicker, createClass, createElement, defaultFormat, div, formatRegex, moment, ref, ref1, ref2, table, tbody, td, th, thead, tr;

ref = require("react"), createClass = ref.createClass, createElement = ref.createElement, (ref1 = ref.DOM, div = ref1.div, table = ref1.table, thead = ref1.thead, tbody = ref1.tbody, th = ref1.th, tr = ref1.tr, td = ref1.td), PropTypes = ref.PropTypes;

ref2 = require("react-bootstrap"), Input = ref2.Input, ButtonToolbar = ref2.ButtonToolbar, ButtonGroup = ref2.ButtonGroup, Button = ref2.Button, DropdownButton = ref2.DropdownButton, MenuItem = ref2.MenuItem, Table = ref2.Table, Glyphicon = ref2.Glyphicon;

moment = require("moment");

defaultFormat = moment.defaultFormat;

formatRegex = /([QeEAaXx]|M{1,4}o?|D{1,4}o?|d{1,4}o?|w{1,2}o?|W{1,2}o?|Y{2,4}|g{2,4}|G{2,4}|H{1,2}|h{1,2}|m{1,2}|s{1,2}|S{1,3}|z{1,2}|Z{1,2})/;

PickerMixin = {
  getDefaultProps: function() {
    var defaultValue, format;
    format = defaultFormat;
    defaultValue = (moment()).format(format);
    return {
      format: format,
      defaultValue: defaultValue
    };
  },
  getInitialState: function() {
    var defaultValue, ref3, value;
    ref3 = this.props, value = ref3.value, defaultValue = ref3.defaultValue;
    if (value == null) {
      value = defaultValue;
    }
    return {
      value: value
    };
  },
  componentWillReceiveProps: function(arg) {
    var value;
    value = arg.value;
    return this.setState({
      value: value
    } || (value != null));
  },
  changeValue: function(fn) {
    var date, format, onChange, ref3, value;
    ref3 = this.props, format = ref3.format, onChange = ref3.onChange;
    value = this.state.value;
    date = moment(value, format);
    fn.call(date);
    value = date.format(format);
    return this.setState({
      value: value
    }, onChange);
  },
  parseFormat: function(format) {
    return format.split(formatRegex);
  },
  moment: function() {
    var format, value;
    format = this.props.format;
    value = this.state.value;
    return moment(value, format);
  },
  getValue: function() {
    return this.state.value;
  },
  tune: function(e, p, n) {
    var delta;
    if (n == null) {
      n = 1;
    }
    e.preventDefault();
    delta = e.deltaY || e.deltaX;
    delta /= -Math.abs(delta);
    delta *= n;
    return this.changeValue(function() {
      return this.add(delta, p);
    });
  }
};

YearPicker = createClass({
  mixins: [PickerMixin],
  getDefaultProps: function() {
    return {
      yearsRange: [-12, 12]
    };
  },
  getInitialState: function() {
    return {
      yearsOffset: 0
    };
  },
  pageYears: function(page) {
    var yearsOffset, yearsRange;
    yearsRange = this.props.yearsRange;
    yearsOffset = this.state.yearsOffset;
    yearsOffset += page * (yearsRange[1] - yearsRange[0]);
    return this.setState({
      yearsOffset: yearsOffset
    });
  },
  prevYears: function() {
    return this.pageYears(-1);
  },
  nextYears: function() {
    return this.pageYears(1);
  },
  pickYear: function(year) {
    return (function(_this) {
      return function() {
        _this.changeValue(function() {
          return this.year(year);
        });
        return _this.setState({
          view: "days"
        });
      };
    })(this);
  },
  render: function() {
    var activeYear, baseYear, col, cols, datetime, firstYear, lastYear, row, rows, year, years, yearsOffset, yearsRange;
    datetime = this.moment();
    yearsRange = this.props.yearsRange;
    yearsOffset = this.state.yearsOffset;
    activeYear = datetime.year();
    baseYear = activeYear + yearsOffset;
    firstYear = yearsRange[0] + baseYear;
    lastYear = yearsRange[1] + baseYear;
    years = yearsRange[1] - yearsRange[0] + 1;
    cols = Math.ceil(Math.sqrt(years));
    rows = Math.ceil(years / cols);
    return table(null, thead(null, tr(null, th({
      colSpan: cols - 1
    }, createElement(Button, {
      bsStyle: "link",
      onClick: this.prevYears
    }, createElement(Glyphicon, {
      glyph: "chevron-left"
    }))), th({
      className: "pull-right"
    }, createElement(Button, {
      bsStyle: "link",
      onClick: this.nextYears
    }, createElement(Glyphicon, {
      glyph: "chevron-right"
    }))))), tbody(null, (function() {
      var i, ref3, results;
      results = [];
      for (row = i = 0, ref3 = rows; 0 <= ref3 ? i < ref3 : i > ref3; row = 0 <= ref3 ? ++i : --i) {
        results.push(tr({
          key: row
        }, (function() {
          var j, ref4, results1;
          results1 = [];
          for (col = j = 0, ref4 = cols; 0 <= ref4 ? j < ref4 : j > ref4; col = 0 <= ref4 ? ++j : --j) {
            year = firstYear + row * cols + col;
            results1.push(td({
              key: col
            }, year <= lastYear ? createElement(Button, {
              bsStyle: year === activeYear ? "primary" : "link",
              onClick: this.pickYear(year)
            }, year) : void 0));
          }
          return results1;
        }).call(this)));
      }
      return results;
    }).call(this)));
  }
});

MonthPicker = createClass({
  mixins: [PickerMixin],
  pickMon: function(mon) {
    return (function(_this) {
      return function() {
        return _this.changeValue(function() {
          return this.month(mon);
        });
      };
    })(this);
  },
  render: function() {
    var activeMonth, col, cols, datetime, month, row, rows;
    datetime = this.moment();
    activeMonth = datetime.month();
    cols = 3;
    rows = 4;
    return table(null, tbody(null, (function() {
      var i, ref3, results;
      results = [];
      for (row = i = 0, ref3 = rows; 0 <= ref3 ? i < ref3 : i > ref3; row = 0 <= ref3 ? ++i : --i) {
        results.push(tr({
          key: row
        }, (function() {
          var j, ref4, results1;
          results1 = [];
          for (col = j = 0, ref4 = cols; 0 <= ref4 ? j < ref4 : j > ref4; col = 0 <= ref4 ? ++j : --j) {
            month = row * cols + col;
            results1.push(td({
              key: col
            }, createElement(Button, {
              bsStyle: month === activeMonth ? "primary" : "link",
              onClick: this.pickMon(month)
            }, (moment(month + 1, "M")).format("MMMM"))));
          }
          return results1;
        }).call(this)));
      }
      return results;
    }).call(this)));
  }
});

DatePicker = createClass({
  mixins: [PickerMixin],
  prevMon: function() {
    return this.changeValue(function() {
      return this.subtract(1, "M");
    });
  },
  nextMon: function() {
    return this.changeValue(function() {
      return this.add(1, "M");
    });
  },
  tuneMon: function(e) {
    return this.tune(e, "M", -1);
  },
  tuneYear: function(e) {
    return this.tune(e, "Y", -1);
  },
  pickDate: function(date) {
    return (function(_this) {
      return function() {
        return _this.changeValue(function() {
          return this.date(date);
        });
      };
    })(this);
  },
  render: function() {
    var activeDate, date, datetime, day, firstDay, firstWeek, lastDay, lastWeek, lastWeekIsFirst, monthDays, onClickMonth, onClickYear, ref3, week;
    ref3 = this.props, onClickYear = ref3.onClickYear, onClickMonth = ref3.onClickMonth;
    datetime = this.moment();
    activeDate = datetime.date();
    monthDays = datetime.daysInMonth();
    firstWeek = ((datetime.clone()).date(1)).week();
    lastWeek = ((datetime.clone()).date(monthDays)).week();
    lastWeekIsFirst = false;
    if (lastWeek < firstWeek) {
      lastWeekIsFirst = true;
      lastDay = monthDays;
      while (lastWeek < firstWeek) {
        lastWeek = ((datetime.clone()).date(lastDay)).week();
        lastDay -= 1;
      }
      lastWeek += 1;
    }
    firstDay = ((datetime.clone()).date(1)).weekday();
    lastDay = ((datetime.clone()).date(monthDays)).weekday();
    return table({
      key: "days"
    }, thead(null, tr(null, th(null, createElement(Button, {
      bsStyle: "link",
      onClick: this.prevMon
    }, createElement(Glyphicon, {
      glyph: "chevron-left"
    }))), th({
      colSpan: 3,
      style: {
        textAlign: "center"
      }
    }, createElement(Button, {
      bsStyle: "link",
      onWheel: this.tuneYear,
      onClick: onClickYear
    }, datetime.format("YYYY"))), th({
      colSpan: 3,
      style: {
        textAlign: "center"
      }
    }, createElement(Button, {
      bsStyle: "link",
      onWheel: this.tuneMon,
      onClick: onClickMonth
    }, datetime.format("MMMM"))), th(null, createElement(Button, {
      bsStyle: "link",
      onClick: this.nextMon
    }, createElement(Glyphicon, {
      glyph: "chevron-right"
    }))))), tbody(null, tr(null, th(null), (function() {
      var i, results;
      results = [];
      for (day = i = 0; i < 7; day = ++i) {
        results.push(th({
          key: day,
          style: {
            textAlign: "center"
          }
        }, (moment(day, "e")).format("ddd")));
      }
      return results;
    })()), (function() {
      var i, ref4, ref5, results;
      results = [];
      for (week = i = ref4 = firstWeek, ref5 = lastWeek; ref4 <= ref5 ? i <= ref5 : i >= ref5; week = ref4 <= ref5 ? ++i : --i) {
        results.push(tr({
          key: week
        }, th(null, week), (function() {
          var j, results1;
          results1 = [];
          for (day = j = 0; j < 7; day = ++j) {
            date = (week - firstWeek) * 7 + day - firstDay + 1;
            results1.push(td({
              key: day
            }, (week !== firstWeek || day >= firstDay) && (week !== lastWeek || day <= lastDay) ? createElement(Button, {
              bsStyle: date === activeDate ? "primary" : "link",
              onClick: this.pickDate(date)
            }, date) : void 0));
          }
          return results1;
        }).call(this)));
      }
      return results;
    }).call(this)));
  }
});

TimePicker = createClass({
  mixins: [PickerMixin],
  getDefaultProps: function() {
    return {
      display: "HH:mm:ss"
    };
  },
  prevHour: function() {
    return this.changeValue(function() {
      return this.subtract(1, "h");
    });
  },
  nextHour: function() {
    return this.changeValue(function() {
      return this.add(1, "h");
    });
  },
  tuneHour: function(e) {
    return this.tune(e, "h");
  },
  prevMin: function() {
    return this.changeValue(function() {
      return this.subtract(1, "m");
    });
  },
  nextMin: function() {
    return this.changeValue(function() {
      return this.add(1, "m");
    });
  },
  tuneMin: function(e) {
    return this.tune(e, "m");
  },
  prevSec: function() {
    return this.changeValue(function() {
      return this.subtract(1, "s");
    });
  },
  nextSec: function() {
    return this.changeValue(function() {
      return this.add(1, "s");
    });
  },
  tuneSec: function(e) {
    return this.tune(e, "s");
  },
  toggleAPM: function() {
    return this.changeValue(function() {
      if (12 >= this.hour()) {
        return this.add(12, "h");
      } else {
        return this.subtract(12, "h");
      }
    });
  },
  render: function() {
    var datetime, index, token, tokens;
    datetime = this.moment();
    tokens = this.parseFormat(this.props.display);
    return table(null, tbody(null, tr(null, (function() {
      var i, len, results;
      results = [];
      for (index = i = 0, len = tokens.length; i < len; index = ++i) {
        token = tokens[index];
        results.push(td({
          key: index
        }, (function() {
          switch (false) {
            case !/^[Hh]/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onClick: this.nextHour
              }, createElement(Glyphicon, {
                glyph: "chevron-up"
              }));
            case !/^m/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onClick: this.nextMin
              }, createElement(Glyphicon, {
                glyph: "chevron-up"
              }));
            case !/^s/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onClick: this.nextSec
              }, createElement(Glyphicon, {
                glyph: "chevron-up"
              }));
          }
        }).call(this)));
      }
      return results;
    }).call(this)), tr(null, (function() {
      var i, len, results;
      results = [];
      for (index = i = 0, len = tokens.length; i < len; index = ++i) {
        token = tokens[index];
        results.push(td({
          key: index
        }, (function() {
          switch (false) {
            case !/^[Hh]/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onWheel: this.tuneHour
              }, datetime.format(token));
            case !/^m/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onWheel: this.tuneMin
              }, datetime.format(token));
            case !/^s/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onWheel: this.tuneSec
              }, datetime.format(token));
            case !/^[aA]/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onClick: this.toggleAPM
              }, datetime.format(token));
            default:
              return token;
          }
        }).call(this)));
      }
      return results;
    }).call(this)), tr(null, (function() {
      var i, len, results;
      results = [];
      for (index = i = 0, len = tokens.length; i < len; index = ++i) {
        token = tokens[index];
        results.push(td({
          key: index
        }, (function() {
          switch (false) {
            case !/^[Hh]/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onClick: this.prevHour
              }, createElement(Glyphicon, {
                glyph: "chevron-down"
              }));
            case !/^m/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onClick: this.prevMin
              }, createElement(Glyphicon, {
                glyph: "chevron-down"
              }));
            case !/^s/.test(token):
              return createElement(Button, {
                bsStyle: "link",
                onClick: this.prevSec
              }, createElement(Glyphicon, {
                glyph: "chevron-down"
              }));
          }
        }).call(this)));
      }
      return results;
    }).call(this))));
  }
});

DateTime = createClass({
  propTypes: function() {
    return {
      label: PropTypes.string,
      help: PropTypes.string,
      format: PropTypes.string,
      display: PropTypes.string,
      value: PropTypes.string,
      defaultValue: PropTypes.string
    };
  },
  getDefaultProps: function() {
    var format;
    format = defaultFormat;
    return {
      format: format,
      datePart: "YYYY-MM-DD",
      timePart: "HH:mm:ss",
      noCaret: true,
      dateGlyph: "calendar",
      timeGlyph: "time",
      defaultValue: (moment()).format(format)
    };
  },
  getInitialState: function() {
    var defaultValue, ref3, value;
    ref3 = this.props, value = ref3.value, defaultValue = ref3.defaultValue;
    if (value == null) {
      value = defaultValue;
    }
    return {
      value: value,
      dateView: "days"
    };
  },
  componentWillReceiveProps: function(arg) {
    var value;
    value = arg.value;
    if (value != null) {
      return this.setState({
        value: value
      });
    }
  },
  viewDays: function() {
    return this.setState({
      dateView: "days"
    });
  },
  viewYears: function() {
    return this.setState({
      dateView: "years"
    });
  },
  viewMonths: function() {
    return this.setState({
      dateView: "months"
    });
  },
  changeValue: function(field) {
    var onChange, value;
    value = this.refs[field].getValue();
    onChange = this.props.onChange;
    if (onChange != null) {
      return onChange(value);
    } else {
      return this.setState({
        value: value
      });
    }
  },
  handleYear: function() {
    this.changeValue("year");
    return this.viewDays();
  },
  handleMonth: function() {
    this.changeValue("month");
    return this.viewDays();
  },
  handleDay: function() {
    return this.changeValue("day");
  },
  handleTime: function() {
    return this.changeValue("time");
  },
  render: function() {
    var addonAfter, addonBefore, bsStyle, dateGlyph, datePart, dateView, datetime, dropup, format, help, label, noCaret, ref3, ref4, timeGlyph, timePart, value;
    ref3 = this.props, label = ref3.label, help = ref3.help, addonBefore = ref3.addonBefore, addonAfter = ref3.addonAfter, format = ref3.format, datePart = ref3.datePart, timePart = ref3.timePart, dateGlyph = ref3.dateGlyph, timeGlyph = ref3.timeGlyph, noCaret = ref3.noCaret, dropup = ref3.dropup, bsStyle = ref3.bsStyle;
    ref4 = this.state, value = ref4.value, dateView = ref4.dateView;
    datetime = moment(value, format);
    return createElement(Input, {
      label: label,
      help: help,
      addonBefore: addonBefore,
      addonAfter: addonAfter
    }, createElement(ButtonToolbar, null, createElement(ButtonGroup, null, datePart ? createElement(DropdownButton, {
      noCaret: noCaret,
      dropup: dropup,
      bsStyle: bsStyle,
      title: [
        datetime.format(datePart), dateGlyph ? " " : void 0, dateGlyph ? createElement(Glyphicon, {
          key: "glyph",
          glyph: dateGlyph
        }) : void 0
      ]
    }, createElement(MenuItem, {
      style: {
        display: "days" === dateView ? "block" : "none"
      },
      header: true
    }, createElement(DatePicker, {
      ref: "day",
      format: format,
      onChange: this.handleDay,
      onClickYear: this.viewYears,
      onClickMonth: this.viewMonths,
      value: value
    })), createElement(MenuItem, {
      style: {
        display: "months" === dateView ? "block" : "none"
      },
      header: true
    }, createElement(MonthPicker, {
      ref: "month",
      format: format,
      onChange: this.handleMonth,
      value: value
    })), createElement(MenuItem, {
      style: {
        display: "years" === dateView ? "block" : "none"
      },
      header: true
    }, createElement(YearPicker, {
      ref: "year",
      format: format,
      onChange: this.handleYear,
      value: value
    }))) : void 0, timePart ? createElement(DropdownButton, {
      noCaret: noCaret,
      dropup: dropup,
      bsStyle: bsStyle,
      title: [
        datetime.format(timePart), timeGlyph ? " " : void 0, timeGlyph ? createElement(Glyphicon, {
          key: "glyph",
          glyph: timeGlyph
        }) : void 0
      ]
    }, createElement(MenuItem, {
      header: true
    }, createElement(TimePicker, {
      ref: "time",
      format: format,
      display: timePart,
      onChange: this.handleTime,
      value: value
    }))) : void 0)));
  }
});

module.exports = {
  PickerMixin: PickerMixin,
  YearPicker: YearPicker,
  MonthPicker: MonthPicker,
  DatePicker: DatePicker,
  TimePicker: TimePicker,
  DateTime: DateTime
};
